Unit AFP1C_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc;

procedure AFP1C(var A :Array of Complex; N :Integer; M :Integer;
                var W :Array of Complex);

implementation

procedure AFP1C(var A :Array of Complex; N :Integer; M :Integer;
                var W :Array of Complex);
var
I,J,B,F :Integer;
C,G,L,Q,R,X,BC,BD,BL :Real;
E,BB :Complex;
label
_1,_2,_3,_4,_5,_6,_7,_8,_9,_10,_11,_12,_13,_14,_15,_16,_17,_18,_19,
_20,_21,_22,_23;
begin
for B:=1 to N do
 begin
  if ( B <> M ) 
   then goto _1;
  W[B-1] := A[(B-1)+(B-1)*N];
  A[(B-1)+(B-1)*N] := Cmplx(0.0,0.0);
  goto _23;
_1:
  for J:=B to M do
   begin
    W[J-1] := A[(B-1)+(J-1)*N];
_2:
   end;
  C := 0.0;
  for J:=B to M do
   begin
    BC := Creal(W[J-1]);
    BD := Aimag(W[J-1]);
    BC := Abs(BC);
    BD := Abs(BD);
    if ( BC-BD ) < 0
     then goto _4
     else if ( BC-BD ) > 0
           then goto _3
           else goto _3;
_3:
    X := BC;
    goto _5;
_4:
    X := BD;
_5:
    if ( X = 0.0 ) 
     then goto _6;
    BC := BC/X;
    BD := BD/X;
    BC := BC*BC+BD*BD;
    X := X*Sqrt(BC);
_6:
    if ( C >= X ) 
     then goto _7;
    C := X;
_7:
   end;
  if ( C = 0.0 ) 
   then goto _22;
  G := 0.0;
  for J:=B to M do
   begin
    L := 0.0;
    BL := Creal(W[J-1])/C;
    L := L+BL*BL;
    BL := Aimag(W[J-1])/C;
    L := L+BL*BL;
    G := G+L;
_8:
   end;
  C := Sqrt(G)*C;
  G := 1.0/C;
  for J:=B to M do
   begin
    W[J-1] := MulC(W[J-1],Cmplx(G,0.0));
_9:
   end;
  Q := Creal(W[B-1]);
  R := Aimag(W[B-1]);
  Q := Abs(Q);
  R := Abs(R);
  if ( Q-R ) < 0
   then goto _11
   else if ( Q-R ) > 0
         then goto _10
         else goto _10;
_10:
  G := Q;
  goto _12;
_11:
  G := R;
_12:
  if ( G = 0.0 ) 
   then goto _13;
  Q := Q/G;
  R := R/G;
  Q := Q*Q+R*R;
  G := G*Sqrt(Q);
_13:
  if ( G <> 0.0 ) 
   then goto _14;
  E := Cmplx(1.0,0.0);
  W[B-1] := Cmplx(1.0,0.0);
  goto _16;
_14:
  E := DivC(W[B-1],Cmplx(G,0.0));
  W[B-1] := AddC(W[B-1],E);
  G := 1.0/Sqrt(1.0+G);
  for J:=B to M do
   begin
    W[J-1] := MulC(W[J-1],Cmplx(G,0.0));
_15:
   end;
_16:
  E := MulC(SubC(Cmplx(0.0,0.0),Cmplx(C,0.0)),E);
  for J:=B to M do
   begin
    A[(B-1)+(J-1)*N] := W[J-1];
_17:
   end;
  if ( B = N ) 
   then goto _21;
  F := B+1;
  for I:=F to N do
   begin
    BB := Cmplx(0.0,0.0);
    for J:=B to M do
     begin
      BB := AddC(BB,MulC(A[(I-1)+(J-1)*N],Conjg(W[J-1])));
_18:
     end;
    for J:=B to M do
     begin
      A[(I-1)+(J-1)*N] := SubC(A[(I-1)+(J-1)*N],MulC(BB,W[J-1]));
_19:
     end;
_20:
   end;
_21:
  W[B-1] := E;
_22:
 end;
_23:
end;

end.
